找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 358|回复: 2

[ARX程序]:c# Arx2

[复制链接]
发表于 2004-9-23 15:39:47 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
#region Using directives

using System;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Colors;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Runtime;
using DBTransMan=Autodesk.AutoCAD.DatabaseServices.TransactionManager;
using Autodesk.AutoCAD.Interop;
using Autodesk.AutoCAD.Interop.Common;
#endregion

namespace ZHFArxLibrary
{
    public class Arx
    {
        private Database db;
        private DBTransMan tm;
        private Transaction myT;
        BlockTable bt;
        BlockTableRecord btr;
        public Arx()
        {
            db = HostApplicationServices.WorkingDatabase;
            tm = db.TransactionManager;
            
        }
        #region Line
        public Line AddLine(Point3d pt1, Point3d pt2)
        {
            Line line;
            try
            {
                Initialize();
                line = new Line(pt1, pt2);
                btr.AppendEntity(line);
                tm.AddNewlyCreatedDBObject(line, true);
                myT.Commit();

            }
            finally
            {
                DisposeAll();
            }
            return line;
        }
        public Line AddLine(Point2d pt1, Point2d pt2)
        {
            Line line;
            line = AddLine(new Point3d(pt1.X, pt1.Y, 0), new Point3d(pt2.X, pt2.Y, 0));
            return line;
        }
        public Line AddLine(Point3d pt1, double x, double y)
        {
            Line line;
            Point3d pt2 = new Point3d();
            pt2.X = pt1.X + x;
            pt2.Y = pt1.Y + y;
            pt2.Z = pt1.Z;
            line = AddLine(pt1, pt2);
            return line;
        }
        public Line AddLineR(Point3d pt1, double angle, double length)
        {
            Line line;
            Point3d pt2 = new Point3d();
            pt2 = GetPointAR(pt1, angle, length);
            line = AddLine(pt1, pt2);
            return line;
        }
        #endregion

        public void Initialize()
        {
            myT = tm.StartTransaction();
            bt = (BlockTable)tm.GetObject(db.BlockTableId, OpenMode.ForRead, false);
            btr = (BlockTableRecord)tm.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite, false);
        }
        public void DisposeAll()
        {
            bt.Close();
            btr.Close();
            myT.Dispose();
        }
        public Point3d GetPointAR(Point3d pt1,double angle,double length)
        {
            Point3d pt2=new Point3d();
            pt2.X = pt1.X + length * Math.Cos(angle);
            pt2.Y = pt1.Y + length * Math.Sin(angle);
            pt2.Z = pt1.Z;
            return pt2;
        }


    }
}
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
发表于 2004-9-28 11:27:36 | 显示全部楼层
还没有学到c#,倒是蛮感兴趣的
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2005-4-12 08:26:06 | 显示全部楼层
可以,继续钻研
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-16 11:26 , Processed in 0.377213 second(s), 36 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表